	let express    = require('express');
	let exec       = require('child_process').exec;		

	function frontendClean(fileName){
		return new Promise((resolve, reject) => {
			
				//' git fetch origin && git reset --hard origin/master '
				exec('cd ' +  fileName + ' && git checkout package.json && npm prune ', (error, stdout, stderr) => {

					if (error) {
						reject(error)
						return;
					}

					console.log(stdout);
					console.log(stderr);
					resolve();
				});
			})

	}


	function frontendPull(fileName){

		return new Promise((resolve, reject) => {
			
			exec('cd ' +  fileName  +' && git pull ', (error, stdout, stderr) => {

				if (error) {
					reject(error)
					return;
				}

				console.log(stdout);
				console.log(stderr);
				resolve();
			});
		})
	} 

	function frontendInstallAddons(fileName, checkedFiles, downloadFiles){
		
		return new Promise((resolve, reject) => {

			checkedPlugins = checkedFiles.filter(function(file){
				return /\bexplorviz-frontend-plugin-\w*/.exec(file);
			});

			if(checkedPlugins.length !== 0 ){
				checkedPlugins.forEach((pluginName) => {
					exec('cd ' + fileName + ' && ember install ' + downloadFiles[pluginName] + ' --save', (error, stdout, stderr) => {
						console.log('in frontendInstallAddons');

						if (error) {
							reject(error);
							return;
						}

						console.log(stdout);
						console.log(stderr);

						resolve();

					});

				})
				//If no plugins were checked by the user, the downloader skips this step by resolving immediately.
			} else {
				resolve();
			}

		})
	}

	function frontendBuild(fileName){

		return new Promise((resolve,reject)=> {
			
			exec('cd ' + fileName +' && ember build --environment=production', (error, stdout, stderr) => {

				if (error) {
					reject(error);
					return;
				}

				console.log(stdout);
				console.log(stderr);

				resolve({zipFileName:'frontend', path:'./explorviz-ui-frontend/dist/'});
			});



		})
		
	}

	module.exports = {
		frontendClean,
		frontendPull,
		frontendInstallAddons,
		frontendBuild
	}
